import { IMetricClient } from './client/IMetricClient';
import { Counter } from './metrics/Counter';
import { Gauge } from './metrics/Gauge';
import { Histogram } from './metrics/Histogram';
import { Timer } from './metrics/Timer';
import { ILogger } from './logging/ILogger';
export declare class Namespace {
    private readonly EmptyValue;
    private metricClient;
    private domain;
    private module;
    private metrics;
    private attributes;
    private logger;
    constructor(metricClient: IMetricClient, domain?: string, module?: string, logger?: ILogger);
    getMetricClient(): IMetricClient;
    getDomain(): string;
    getModule(): string;
    getNamespacePrefix(): string;
    getAttributes(): Record<string, string>;
    getAttribute(attributeName: string): string | undefined;
    setAttribute(attributeName: string, attributeValue: string): void;
    removeAttribute(attributeName: string): void;
    getGauge(metricName: string): Gauge | undefined;
    createGauge(metricName: string, description?: string, unit?: string): Gauge;
    recordGauge(metricName: string, value: number, attributes: Record<string, string>): void;
    getCounter(metricName: string): Counter | undefined;
    createCounter(metricName: string, description?: string, unit?: string): Counter;
    incrementCounter(metricName: string, value: number, attributes: Record<string, string>): void;
    getHistogram(metricName: string): Histogram | undefined;
    createHistogram(metricName: string, description?: string, unit?: string): Histogram;
    recordHistogram(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    getTimer(metricName: string): Timer | undefined;
    createTimer(metricName: string, description?: string, unit?: string): Timer;
    recordTimer(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    private isEmptyNamespace;
    private getMetricKey;
}
